=== debian/changelog ===
wlmaker (0.7.1-2) experimental; urgency=medium

  * d/control: update build-depends libwlroots-dev to 0.20.

 -- Alex Myczko <tar@debian.org>  Sat, 14 Feb 2026 16:10:06 +0000

wlmaker (0.7.1-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sat, 14 Feb 2026 16:04:08 +0000
